## eliom 4.2

=== Makefile ===
### Building
BUILDER=_build/build/build.native
BUILD=ocaml pkg/build.ml

.PHONY: all byte opt builder
all: $(BUILDER)
	$(BUILD) manpage=false native=true native-dynlink=true
byte: $(BUILDER)
	$(BUILD) manpage=false native=false native-dynlink=false
opt: $(BUILDER)
	$(BUILD) manpage=false native=true native-dynlink=true

$(BUILDER): $(wildcard build/*.ml)
	ocamlbuild -no-plugin -I src/ocamlbuild -no-links -use-ocamlfind build/build.native 1> /dev/null
builder: $(BUILDER)
### Doc
.PHONY: doc wikidoc doc man alldoc
DOCS_DIR=src/lib/client src/lib/server src/ocamlbuild
DOCS_HTML=$(addsuffix /api.docdir/index.html,$(DOCS_DIR))
DOCS_WIKI=$(addsuffix /api.wikidocdir/index.wiki,$(DOCS_DIR))
DOCS_MAN= src/lib/client/api.mandocdir/man.3oc \
          src/lib/server/api.mandocdir/man.3os \
          src/ocamlbuild/api.mandocdir/man.3o
doc: $(BUILDER)
	$(BUILDER) $(DOCS_HTML)
wikidoc: $(BUILDER)
	$(BUILDER) $(DOCS_WIKI)
man: $(BUILDER)
	$(BUILDER) $(DOCS_MAN)
alldoc: man wikidoc doc

### Testing ###

.PHONY: run.local run.opt.local links

run.local: tests.byte fifo tests/eliom.conf
	OCAMLPATH=tests/:$(OCAMLPATH) ocsigenserver -c tests/eliom.conf

run.opt.local: tests.opt fifo tests/eliom.conf
	OCAMLPATH=tests/:$(OCAMLPATH) ocsigenserver.opt -c tests/eliom.conf

tests.byte: links
	${MAKE} -C tests byte

tests.opt: links
	${MAKE} -C tests opt

links:
	-mkdir -p local/var/run
	-mkdir -p local/var/log
	-mkdir -p local/var/lib
	-mkdir -p local/tmp

fifo:
	[ -p local/var/run/eliom_command ] || \
	 { mkfifo local/var/run/eliom_command; \
	   chmod 660 local/var/run/eliom_command; }


### Cleaning ###
.PHONY: clean clean.local distclean
clean: clean.local
	ocamlbuild -quiet -no-plugin -clean
	${MAKE} -C tests clean

clean.local:
	-rm -f eliom-*.tar.gz

distclean: clean clean.local
	${MAKE} -C tests distclean
	-find ./ -name "*\#*" | xargs rm -f

### Installation ####
.PHONY: install uninstall reinstall


install uninstall: eliom.install
ifneq ($(PREFIX),)
	opam-installer --$@ --prefix $(PREFIX) eliom.install
else
	@echo you must provide a prefix with : make PREFIX=myprefix $@
endif

reinstall:
	${MAKE} uninstall
	${MAKE} install

=== tests/distillery/Makefile ===
#### Distillery ####

.PHONY: byte opt clean

DISTILLERY := eliom-distillery
ALL = basic mobile

byte:
	for i in $(ALL); do $(MAKE) byte-$$i; done

opt:
	for i in $(ALL); do $(MAKE) opt-$$i; done

distillery-%:
	mkdir -p $@
	$(DISTILLERY) -name distillery_$* -template $* -target-directory $@
	echo 'TEST_PREFIX=local/' >> $@/Makefile.options
	echo 'PREFIX=../../../local/' >> $@/Makefile.options
	echo 'STATICDIR=var/www/$@/static' >> $@/Makefile.options
	echo 'ELIOMSTATICDIR=var/www/$@/eliomstatic' >> $@/Makefile.options
	echo 'LIBDIR=var/www/$@/lib' >> $@/Makefile.options
	echo 'WWWUSER=' >> $@/Makefile.options
	echo 'WWWGROUP=' >> $@/Makefile.options
	make -C $@ byte install.static

byte-%: | distillery-%
	make -C distillery-$* byte install.byte
opt-%: | distillery-%
	make -C distillery-$* opt install.opt

clean:
	for i in $(ALL); do rm -Rf distillery-$$i clean; done

distclean: clean

=== tests/miniwiki/Makefile ===
OCB=ocamlbuild -use-ocamlfind -tag thread -package eliom.server

byte:
	$(OCB) miniwiki.cma
opt:
	$(OCB) miniwiki.cmxs

clean:
	$(OCB) -clean
distclean: clean

=== tests/testsuite/Makefile ===
OCB=eliombuild

client:
	$(OCB) testsuite_client.js

byte: client
	$(OCB) testsuite.cma \
         server/eliom_testsuite_global.cma \
         server/eliom_testsuite_site.cma
opt: client
	$(OCB) testsuite.cmxs \
         server/eliom_testsuite_global.cmxs \
         server/eliom_testsuite_site.cmxs
build-%:
	$(OCB) $*

clean:
	rm -Rf _build
distclean: clean

=== doc/manual-wiki/illustrations/Makefile ===

DENSITY=300

.PHONY: all clean
all: compilation.png

%.pdf: %.pgf
	pdflatex --jobname=$(basename $<) "\documentclass{standalone}\usepackage{my-pgf}\begin{document}\input{$<}\end{document}"

%.png: %.pdf
	convert -density $(DENSITY) $< $@

clean:
	rm -rf *.aux *.log

=== pkg/distillery/basic/Makefile ===

##----------------------------------------------------------------------
## DISCLAIMER
##
## This file contains the rules to make an Eliom project. The project is
## configured through the variables in the file Makefile.options.
##----------------------------------------------------------------------

include Makefile.options

##----------------------------------------------------------------------
##			      Internals

## Required binaries
ELIOMC            := eliomc
ELIOMOPT          := eliomopt
JS_OF_ELIOM       := js_of_eliom
ELIOMDEP          := eliomdep
OCSIGENSERVER     := ocsigenserver
OCSIGENSERVER.OPT := ocsigenserver.opt

## Where to put intermediate object files.
## - ELIOM_{SERVER,CLIENT}_DIR must be distinct
## - ELIOM_CLIENT_DIR must not be the local dir.
## - ELIOM_SERVER_DIR could be ".", but you need to
##   remove it from the "clean" rules...
export ELIOM_SERVER_DIR := _server
export ELIOM_CLIENT_DIR := _client
export ELIOM_TYPE_DIR   := _server
DEPSDIR := _deps

ifeq ($(DEBUG),yes)
  GENERATE_DEBUG ?= -g
  RUN_DEBUG ?= "-v"
  DEBUG_JS ?= -jsopt -pretty -jsopt -noinline -jsopt -debuginfo
endif

##----------------------------------------------------------------------
## General

.PHONY: all byte opt
all: byte opt
byte opt:: $(TEST_PREFIX)$(ELIOMSTATICDIR)/${PROJECT_NAME}.js
byte opt:: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf
byte opt:: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME)-test.conf
byte:: $(TEST_PREFIX)$(LIBDIR)/${PROJECT_NAME}.cma
opt:: $(TEST_PREFIX)$(LIBDIR)/${PROJECT_NAME}.cmxs

DIST_DIRS = $(ETCDIR) $(DATADIR) $(LIBDIR) $(LOGDIR) $(STATICDIR) $(ELIOMSTATICDIR) $(shell dirname $(CMDPIPE))

##----------------------------------------------------------------------
## Testing

DIST_FILES = $(ELIOMSTATICDIR)/$(PROJECT_NAME).js $(LIBDIR)/$(PROJECT_NAME).cma

.PHONY: test.byte test.opt
test.byte: $(addprefix $(TEST_PREFIX),$(ETCDIR)/$(PROJECT_NAME)-test.conf $(DIST_DIRS) $(DIST_FILES))
	$(OCSIGENSERVER) $(RUN_DEBUG) -c $<
test.opt: $(addprefix $(TEST_PREFIX),$(ETCDIR)/$(PROJECT_NAME)-test.conf $(DIST_DIRS) $(patsubst %.cma,%.cmxs, $(DIST_FILES)))
	$(OCSIGENSERVER.OPT) $(RUN_DEBUG) -c $<

$(addprefix $(TEST_PREFIX), $(DIST_DIRS)):
	mkdir -p $@

##----------------------------------------------------------------------
## Installing & Running

.PHONY: install install.byte install.byte install.opt install.static install.etc install.lib install.lib.byte install.lib.opt run.byte run.opt
install: install.byte install.opt
install.byte: install.lib.byte install.etc install.static | $(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(shell dirname $(CMDPIPE)))
install.opt: install.lib.opt install.etc install.static | $(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(shell dirname $(CMDPIPE)))
install.lib: install.lib.byte install.lib.opt
install.lib.byte: $(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cma | $(PREFIX)$(LIBDIR)
	install $< $(PREFIX)$(LIBDIR)
install.lib.opt: $(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cmxs | $(PREFIX)$(LIBDIR)
	install $< $(PREFIX)$(LIBDIR)
install.static: $(TEST_PREFIX)$(ELIOMSTATICDIR)/$(PROJECT_NAME).js | $(PREFIX)$(STATICDIR) $(PREFIX)$(ELIOMSTATICDIR)
	cp -r $(LOCAL_STATIC)/* $(PREFIX)$(STATICDIR)
	[ -z $(WWWUSER) ] || chown -R $(WWWUSER) $(PREFIX)$(STATICDIR)
	install $(addprefix -o ,$(WWWUSER)) $< $(PREFIX)$(ELIOMSTATICDIR)
install.etc: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf | $(PREFIX)$(ETCDIR)
	install $< $(PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf

.PHONY:
print-install-files:
	@echo $(PREFIX)$(LIBDIR)
	@echo $(PREFIX)$(STATICDIR)
	@echo $(PREFIX)$(ELIOMSTATICDIR)
	@echo $(PREFIX)$(ETCDIR)

$(addprefix $(PREFIX),$(ETCDIR) $(LIBDIR)):
	install -d $@
$(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(STATICDIR) $(ELIOMSTATICDIR) $(shell dirname $(CMDPIPE))):
	install $(addprefix -o ,$(WWWUSER)) -d $@

run.byte:
	$(OCSIGENSERVER) $(RUN_DEBUG) -c ${PREFIX}${ETCDIR}/${PROJECT_NAME}.conf
run.opt:
	$(OCSIGENSERVER.OPT) $(RUN_DEBUG) -c ${PREFIX}${ETCDIR}/${PROJECT_NAME}.conf

##----------------------------------------------------------------------
## Aux

# Use `eliomdep -sort' only in OCaml>4
ifeq ($(shell ocamlc -version|cut -c1),4)
eliomdep=$(shell $(ELIOMDEP) $(1) -sort $(2) $(filter %.eliom %.ml,$(3))))
else
eliomdep=$(3)
endif
objs=$(patsubst %.ml,$(1)/%.$(2),$(patsubst %.eliom,$(1)/%.$(2),$(filter %.eliom %.ml,$(3))))
depsort=$(call objs,$(1),$(2),$(call eliomdep,$(3),$(4),$(5)))

##----------------------------------------------------------------------
## Config files

FINDLIB_PACKAGES=$(patsubst %,\<extension\ findlib-package=\"%\"\ /\>,$(SERVER_PACKAGES))
EDIT_WARNING=DON\'T EDIT THIS FILE! It is generated from $(PROJECT_NAME).conf.in, edit that one, or the variables in Makefile.options
SED_ARGS := -e "/^ *%%%/d"
SED_ARGS += -e "s|%%PROJECT_NAME%%|$(PROJECT_NAME)|g"
SED_ARGS += -e "s|%%DATABASE_NAME%%|$(DATABASE_NAME)|g"
SED_ARGS += -e "s|%%DATABASE_USER%%|$(DATABASE_USER)|g"
SED_ARGS += -e "s|%%CMDPIPE%%|%%PREFIX%%$(CMDPIPE)|g"
SED_ARGS += -e "s|%%LOGDIR%%|%%PREFIX%%$(LOGDIR)|g"
SED_ARGS += -e "s|%%DATADIR%%|%%PREFIX%%$(DATADIR)|g"
SED_ARGS += -e "s|%%PERSISTENT_DATA_BACKEND%%|$(PERSISTENT_DATA_BACKEND)|g"
SED_ARGS += -e "s|%%LIBDIR%%|%%PREFIX%%$(LIBDIR)|g"
SED_ARGS += -e "s|%%WARNING%%|$(EDIT_WARNING)|g"
SED_ARGS += -e "s|%%PACKAGES%%|$(FINDLIB_PACKAGES)|g"
SED_ARGS += -e "s|%%ELIOMSTATICDIR%%|%%PREFIX%%$(ELIOMSTATICDIR)|g"
ifeq ($(DEBUG),yes)
  SED_ARGS += -e "s|%%DEBUGMODE%%|\<debugmode /\>|g"
else
  SED_ARGS += -e "s|%%DEBUGMODE%%||g"
endif

LOCAL_SED_ARGS := -e "s|%%PORT%%|$(TEST_PORT)|g"
LOCAL_SED_ARGS += -e "s|%%STATICDIR%%|$(LOCAL_STATIC)|g"
LOCAL_SED_ARGS += -e "s|%%USERGROUP%%||g"
GLOBAL_SED_ARGS := -e "s|%%PORT%%|$(PORT)|g"
GLOBAL_SED_ARGS += -e "s|%%STATICDIR%%|%%PREFIX%%$(STATICDIR)|g"
ifeq ($(WWWUSER)$(WWWGROUP),)
  GLOBAL_SED_ARGS += -e "s|%%USERGROUP%%||g"
else
  GLOBAL_SED_ARGS += -e "s|%%USERGROUP%%|<user>$(WWWUSER)</user><group>$(WWWGROUP)</group>|g"
endif

$(TEST_PREFIX)${ETCDIR}/${PROJECT_NAME}.conf: ${PROJECT_NAME}.conf.in Makefile.options | $(TEST_PREFIX)$(ETCDIR)
	sed $(SED_ARGS) $(GLOBAL_SED_ARGS) $< | sed -e "s|%%PREFIX%%|$(PREFIX)|g" > $@
$(TEST_PREFIX)${ETCDIR}/${PROJECT_NAME}-test.conf: ${PROJECT_NAME}.conf.in Makefile.options | $(TEST_PREFIX)$(ETCDIR)
	sed $(SED_ARGS) $(LOCAL_SED_ARGS) $< | sed -e "s|%%PREFIX%%|$(TEST_PREFIX)|g" > $@

##----------------------------------------------------------------------
## Server side compilation

SERVER_INC  := ${addprefix -package ,${SERVER_PACKAGES}}

${ELIOM_TYPE_DIR}/%.type_mli: %.eliom
	${ELIOMC} -infer ${SERVER_INC} $<

$(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cma: $(call objs,$(ELIOM_SERVER_DIR),cmo,$(SERVER_FILES)) | $(TEST_PREFIX)$(LIBDIR)
	${ELIOMC} -a -o $@ $(GENERATE_DEBUG) \
          $(call depsort,$(ELIOM_SERVER_DIR),cmo,-server,$(SERVER_INC),$(SERVER_FILES))

$(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cmxa: $(call objs,$(ELIOM_SERVER_DIR),cmx,$(SERVER_FILES)) | $(TEST_PREFIX)$(LIBDIR)
	${ELIOMOPT} -a -o $@ $(GENERATE_DEBUG) \
          $(call depsort,$(ELIOM_SERVER_DIR),cmx,-server,$(SERVER_INC),$(SERVER_FILES))

%.cmxs: %.cmxa
	$(ELIOMOPT) -shared -linkall -o $@ $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmi: %.mli
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmi: %.eliomi
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmo: %.ml
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmo: %.eliom
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmx: %.ml
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmx: %.eliom
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<


##----------------------------------------------------------------------
## Client side compilation

CLIENT_LIBS := ${addprefix -package ,${CLIENT_PACKAGES}}
CLIENT_INC  := ${addprefix -package ,${CLIENT_PACKAGES}}

CLIENT_OBJS := $(filter %.eliom %.ml, $(CLIENT_FILES))
CLIENT_OBJS := $(patsubst %.eliom,${ELIOM_CLIENT_DIR}/%.cmo, ${CLIENT_OBJS})
CLIENT_OBJS := $(patsubst %.ml,${ELIOM_CLIENT_DIR}/%.cmo, ${CLIENT_OBJS})

$(TEST_PREFIX)$(ELIOMSTATICDIR)/$(PROJECT_NAME).js: $(call objs,$(ELIOM_CLIENT_DIR),cmo,$(CLIENT_FILES)) | $(TEST_PREFIX)$(ELIOMSTATICDIR)
	${JS_OF_ELIOM} -o $@ $(GENERATE_DEBUG) $(CLIENT_INC) $(DEBUG_JS) \
          $(call depsort,$(ELIOM_CLIENT_DIR),cmo,-client,$(CLIENT_INC),$(CLIENT_FILES))

${ELIOM_CLIENT_DIR}/%.cmi: %.mli
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmo: %.eliom
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<
${ELIOM_CLIENT_DIR}/%.cmo: %.ml
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmi: %.eliomi
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

##----------------------------------------------------------------------
## Dependencies

include .depend

.depend: $(patsubst %,$(DEPSDIR)/%.server,$(SERVER_FILES)) $(patsubst %,$(DEPSDIR)/%.client,$(CLIENT_FILES))
	cat $^ > $@

$(DEPSDIR)/%.server: % | $(DEPSDIR)
	$(ELIOMDEP) -server $(SERVER_INC) $< > $@

$(DEPSDIR)/%.client: % | $(DEPSDIR)
	$(ELIOMDEP) -client $(CLIENT_INC) $< > $@

$(DEPSDIR):
	mkdir $@

##----------------------------------------------------------------------
## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f *.type_mli
	-rm -f ${PROJECT_NAME}.js
	-rm -rf ${ELIOM_CLIENT_DIR} ${ELIOM_SERVER_DIR}

distclean: clean
	-rm -rf $(TEST_PREFIX) $(DEPSDIR) .depend

=== debian/changelog ===
eliom (4.2-2) unstable; urgency=medium

  * Fix compilation on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Tue, 26 Jan 2016 09:34:47 +0100

eliom (4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #802860)
  * Simplify packaging by removing libeliom-ocaml
  * Bump Standards-Version to 3.9.6

 -- Stéphane Glondu <glondu@debian.org>  Thu, 07 Jan 2016 13:35:19 +0100

=== debian/control ===
Source: eliom
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Stéphane Glondu <glondu@debian.org>,
  Pierre Chambart <pierre.chambart@crans.org>
Build-Depends:
  debhelper (>= 9),
  dh-ocaml,
  libocsigenserver-ocaml-dev (>= 2.4),
  libderiving-ocsigen-ocaml-dev (>= 0.6),
  libjs-of-ocaml-dev (>= 2.2),
  libcalendar-ocaml-dev (>= 2.03.1),
  liblwt-ssl-ocaml-dev,
  libreactivedata-ocaml-dev,
  js-of-ocaml (>= 2.5-2~),
  libtyxml-ocaml-dev (>= 3),
  liboptcomp-camlp4-dev,
  opam,
  ocaml-findlib,
  ocaml-nox
Standards-Version: 3.9.6
Homepage: http://ocsigen.org/eliom
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/eliom.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/eliom.git

Package: eliom
Architecture: any
Depends:
 libeliom-ocaml-dev,
 ocaml-findlib,
 js-of-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libeliom-ocaml-doc
Replaces: libeliom-ocaml-dev (<< 3)
Breaks: libeliom-ocaml-dev (<< 3)
Description: web framework for ocsigenserver (tools)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains command-line tools.

Package: libeliom-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Breaks: libeliom-ocaml (<< 4.2)
Replaces: libeliom-ocaml (<< 4.2)
Description: web framework for ocsigenserver (dev libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains all the library files needed to use Eliom.

Package: libeliom-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: libeliom-ocaml-dev
Description: web framework for ocsigenserver (documentation)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
MANDIR=$(DESTDIR)/usr/share/man

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

# This should test OCAML_HAVE_OCAMLOPT, but camlp4 usage seems to
# force dynlink...
ifeq ($(OCAML_NATDYNLINK),yes)
  BUILD_TARGET := all
else
  BUILD_TARGET := byte
endif

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)
	$(MAKE) man doc

.PHONY: override_dh_auto_install
override_dh_auto_install:
	opam-installer --prefix=debian/tmp/usr --libdir=$(subst /usr/,,$(OCAML_STDLIB_DIR)) --mandir=share/man --docdir=share/doc eliom.install

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

## eliom 6.12.1

=== Makefile ===
--- 
+++ 
@@ -15,12 +15,13 @@
 builder: $(BUILDER)
 ### Doc
 .PHONY: doc wikidoc doc man alldoc
-DOCS_DIR=src/lib/client src/lib/server src/ocamlbuild
+DOCS_DIR=src/lib/client src/lib/server src/ocamlbuild src/ppx
 DOCS_HTML=$(addsuffix /api.docdir/index.html,$(DOCS_DIR))
 DOCS_WIKI=$(addsuffix /api.wikidocdir/index.wiki,$(DOCS_DIR))
 DOCS_MAN= src/lib/client/api.mandocdir/man.3oc \
           src/lib/server/api.mandocdir/man.3os \
-          src/ocamlbuild/api.mandocdir/man.3o
+          src/ocamlbuild/api.mandocdir/man.3o \
+          src/ppx/api.mandocdir/man.3o
 doc: $(BUILDER)
 	$(BUILDER) $(DOCS_HTML)
 wikidoc: $(BUILDER)

=== debian/changelog ===
eliom (6.12.1-3build1) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Sep 2020 14:04:04 +0200

eliom (6.12.1-3) unstable; urgency=medium

  * libeliom-ocaml-dev: add explicit libppx-deriving-ocaml-dev to Depends
  * libeliom-ocaml-doc: add Multi-Arch: foreign

 -- Stéphane Glondu <glondu@debian.org>  Fri, 14 Aug 2020 10:33:37 +0200

eliom (6.12.1-2) unstable; urgency=medium

  * Make bytecode patch more generic (should fix FTBFS on bytecode)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Aug 2020 12:36:08 +0200

eliom (6.12.1-1) unstable; urgency=medium

  * New upstream release (Closes: #956887)
  * Remove Pierre from Uploaders
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no
  * Update Vcs-* to point to salsa
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Aug 2020 17:04:58 +0200

eliom (4.2-3) unstable; urgency=medium

  * Add camlp4 to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Mon, 22 Aug 2016 16:44:07 +0200

## eliom 6.12.4

=== Makefile ===
--- 
+++ 
@@ -1,17 +1,20 @@
 ### Building
-BUILDER=_build/build/build.native
+BEST=$(if $(shell command -v ocamlopt 2> /dev/null),native,byte)
+BUILDER=_build/build/build.$(BEST)
 BUILD=ocaml pkg/build.ml
 
-.PHONY: all byte opt builder
-all: $(BUILDER)
-	$(BUILD) manpage=false native=true native-dynlink=true
+.PHONY: all byte native builder
+all: $(BEST)
+
 byte: $(BUILDER)
+	# strange, see https://sympa.inria.fr/sympa/arc/ocsigen/2016-01/msg00016.html
+	$(BUILDER) src/lib/server/eliommod_sessiongroups.cmi
 	$(BUILD) manpage=false native=false native-dynlink=false
-opt: $(BUILDER)
+native: $(BUILDER)
 	$(BUILD) manpage=false native=true native-dynlink=true
 
 $(BUILDER): $(wildcard build/*.ml)
-	ocamlbuild -no-plugin -I src/ocamlbuild -no-links -use-ocamlfind build/build.native 1> /dev/null
+	ocamlbuild -no-plugin -I src/ocamlbuild -no-links -use-ocamlfind build/build.$(BEST) 1> /dev/null
 builder: $(BUILDER)
 ### Doc
 .PHONY: doc wikidoc doc man alldoc

=== tests/Makefile ===
TARGETS=miniwiki testsuite distillery

.PHONY: clean distclean byte opt
clean:
	for i in $(TARGETS); do $(MAKE) -C $$i clean; done
distclean: clean
	for i in $(TARGETS); do $(MAKE) -C $$i distclean; done

byte:
	for i in $(TARGETS); do $(MAKE) -C $$i byte; done
opt: clean
	for i in $(TARGETS); do $(MAKE) -C $$i opt; done

=== debian/changelog ===
eliom (6.12.4-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 11 Nov 2020 03:37:28 +0100

=== debian/control ===
--- 
+++ 
@@ -3,27 +3,28 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
-  Stéphane Glondu <glondu@debian.org>,
-  Pierre Chambart <pierre.chambart@crans.org>
+ Stéphane Glondu <glondu@debian.org>
 Build-Depends:
-  debhelper (>= 9),
-  dh-ocaml,
-  libocsigenserver-ocaml-dev (>= 2.4),
-  libderiving-ocsigen-ocaml-dev (>= 0.6),
-  libjs-of-ocaml-dev (>= 2.2),
-  libcalendar-ocaml-dev (>= 2.03.1),
-  liblwt-ssl-ocaml-dev,
-  libreactivedata-ocaml-dev,
-  js-of-ocaml (>= 2.5-2~),
-  libtyxml-ocaml-dev (>= 3),
-  liboptcomp-camlp4-dev,
-  opam,
-  ocaml-findlib,
-  ocaml-nox
-Standards-Version: 3.9.6
+ debhelper-compat (= 13),
+ dh-ocaml,
+ ocaml-nox (>= 4.07.1),
+ ocaml-findlib,
+ ocamlbuild,
+ libppx-deriving-ocaml-dev,
+ libppx-tools-ocaml-dev,
+ libjs-of-ocaml-dev (>= 3.5.1),
+ liblwt-log-ocaml-dev,
+ liblwt-ocaml-dev,
+ libtyxml-ocaml-dev (>= 4.4.0),
+ libocsigenserver-ocaml-dev (>= 2.10),
+ libipaddr-ocaml-dev (>= 2.1),
+ libreactivedata-ocaml-dev (>= 0.2.1),
+ opam-installer
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://ocsigen.org/eliom
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/eliom.git
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/eliom.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/eliom
+Vcs-Git: https://salsa.debian.org/ocaml-team/eliom.git
 
 Package: eliom
 Architecture: any
@@ -47,6 +48,7 @@
 Package: libeliom-ocaml-dev
 Architecture: any
 Depends:
+ libppx-deriving-ocaml-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
@@ -64,6 +66,7 @@
 Package: libeliom-ocaml-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Enhances: libeliom-ocaml-dev
 Description: web framework for ocsigenserver (documentation)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
MANDIR=$(DESTDIR)/usr/share/man

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) all
	$(MAKE) man doc

override_dh_auto_install:
	opam-installer --prefix=debian/tmp/usr --libdir=$(subst /usr/,,$(OCAML_STDLIB_DIR)) --mandir=share/man --docdir=share/doc eliom.install

=== debian/watch ===
version=3
https://github.com/ocsigen/eliom/tags .*/archive/([0-9.]+)\.tar\.gz

## eliom 9.4.0

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
           src/lib/server/api.mandocdir/man.3os \
           src/ocamlbuild/api.mandocdir/man.3o \
           src/ppx/api.mandocdir/man.3o
+API_DIR=_build/doc/dev/api
 doc: $(BUILDER)
 	$(BUILDER) $(DOCS_HTML)
 wikidoc: $(BUILDER)
@@ -32,6 +33,15 @@
 man: $(BUILDER)
 	$(BUILDER) $(DOCS_MAN)
 alldoc: man wikidoc doc
+
+doccp: alldoc
+	mkdir -p $(API_DIR)/server $(API_DIR)/client $(API_DIR)/ocamlbuild $(API_DIR)/ppx
+	cp -Rf _build/src/lib/server/api.wikidocdir/*.wiki $(API_DIR)/server/
+	cp -Rf _build/src/lib/client/api.wikidocdir/*.wiki $(API_DIR)/client/
+	cp -Rf _build/src/ocamlbuild/api.wikidocdir/*.wiki $(API_DIR)/ocamlbuild/
+	cp -Rf _build/src/ppx/api.wikidocdir/*.wiki $(API_DIR)/ppx/
+	cp -Rf doc/index.wiki $(API_DIR)/
+
 
 ### Testing ###

=== tests-deprecated/distillery/Makefile ===
#### Distillery ####

.PHONY: byte opt clean

DISTILLERY := eliom-distillery
ALL = basic.camlp4

byte:
	for i in $(ALL); do $(MAKE) byte-$$i; done

opt:
	for i in $(ALL); do $(MAKE) opt-$$i; done

distillery-%:
	mkdir -p $@
	$(DISTILLERY) -name distillery_$(subst .,_,$*) -template $* -target-directory $@
	echo 'TEST_PREFIX=local/' >> $@/Makefile.options
	echo 'PREFIX=../../../local/' >> $@/Makefile.options
	echo 'STATICDIR=var/www/$@/static' >> $@/Makefile.options
	echo 'ELIOMSTATICDIR=var/www/$@/eliomstatic' >> $@/Makefile.options
	echo 'LIBDIR=var/www/$@/lib' >> $@/Makefile.options
	echo 'WWWUSER=' >> $@/Makefile.options
	echo 'WWWGROUP=' >> $@/Makefile.options
	make -C $@ byte install.static

byte-%: | distillery-%
	make -C distillery-$* byte install.byte
opt-%: | distillery-%
	make -C distillery-$* opt install.opt

clean:
	for i in $(ALL); do rm -Rf distillery-$$i clean; done

distclean: clean

=== pkg/distillery/basic.ppx/Makefile ===

##----------------------------------------------------------------------
## DISCLAIMER
##
## This file contains the rules to make an Eliom project. The project is
## configured through the variables in the file Makefile.options.
##----------------------------------------------------------------------

include Makefile.options

##----------------------------------------------------------------------
##			      Internals

## Required binaries
ELIOMC            := eliomc -ppx
ELIOMOPT          := eliomopt -ppx
JS_OF_ELIOM       := js_of_eliom -ppx
ELIOMDEP          := eliomdep
OCSIGENSERVER     := ocsigenserver
OCSIGENSERVER.OPT := ocsigenserver.opt

## Where to put intermediate object files.
## - ELIOM_{SERVER,CLIENT}_DIR must be distinct
## - ELIOM_CLIENT_DIR must not be the local dir.
## - ELIOM_SERVER_DIR could be ".", but you need to
##   remove it from the "clean" rules...
export ELIOM_SERVER_DIR := _server
export ELIOM_CLIENT_DIR := _client
export ELIOM_TYPE_DIR   := _server
DEPSDIR := _deps

ifeq ($(DEBUG),yes)
  GENERATE_DEBUG ?= -g
  RUN_DEBUG ?= "-v"
  DEBUG_JS ?= -jsopt -pretty -jsopt -noinline -jsopt -debuginfo
endif

##----------------------------------------------------------------------
## General

.PHONY: all byte opt
all: byte opt
byte opt:: $(TEST_PREFIX)$(ELIOMSTATICDIR)/${PROJECT_NAME}.js
byte opt:: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf
byte opt:: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME)-test.conf
byte:: $(TEST_PREFIX)$(LIBDIR)/${PROJECT_NAME}.cma
opt:: $(TEST_PREFIX)$(LIBDIR)/${PROJECT_NAME}.cmxs

DIST_DIRS = $(ETCDIR) $(DATADIR) $(LIBDIR) $(LOGDIR) $(STATICDIR) $(ELIOMSTATICDIR) $(shell dirname $(CMDPIPE))

##----------------------------------------------------------------------
## Testing

DIST_FILES = $(ELIOMSTATICDIR)/$(PROJECT_NAME).js $(LIBDIR)/$(PROJECT_NAME).cma

.PHONY: test.byte test.opt
test.byte: $(addprefix $(TEST_PREFIX),$(ETCDIR)/$(PROJECT_NAME)-test.conf $(DIST_DIRS) $(DIST_FILES))
	$(OCSIGENSERVER) $(RUN_DEBUG) -c $<
test.opt: $(addprefix $(TEST_PREFIX),$(ETCDIR)/$(PROJECT_NAME)-test.conf $(DIST_DIRS) $(patsubst %.cma,%.cmxs, $(DIST_FILES)))
	$(OCSIGENSERVER.OPT) $(RUN_DEBUG) -c $<

$(addprefix $(TEST_PREFIX), $(DIST_DIRS)):
	mkdir -p $@

##----------------------------------------------------------------------
## Installing & Running

.PHONY: install install.byte install.byte install.opt install.static install.etc install.lib install.lib.byte install.lib.opt run.byte run.opt
install: install.byte install.opt
install.byte: install.lib.byte install.etc install.static | $(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(shell dirname $(CMDPIPE)))
install.opt: install.lib.opt install.etc install.static | $(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(shell dirname $(CMDPIPE)))
install.lib: install.lib.byte install.lib.opt
install.lib.byte: $(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cma | $(PREFIX)$(LIBDIR)
	install $< $(PREFIX)$(LIBDIR)
install.lib.opt: $(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cmxs | $(PREFIX)$(LIBDIR)
	install $< $(PREFIX)$(LIBDIR)
install.static: $(TEST_PREFIX)$(ELIOMSTATICDIR)/$(PROJECT_NAME).js | $(PREFIX)$(STATICDIR) $(PREFIX)$(ELIOMSTATICDIR)
	cp -r $(LOCAL_STATIC)/* $(PREFIX)$(STATICDIR)
	[ -z $(WWWUSER) ] || chown -R $(WWWUSER) $(PREFIX)$(STATICDIR)
	install $(addprefix -o ,$(WWWUSER)) $< $(PREFIX)$(ELIOMSTATICDIR)
install.etc: $(TEST_PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf | $(PREFIX)$(ETCDIR)
	install $< $(PREFIX)$(ETCDIR)/$(PROJECT_NAME).conf

.PHONY:
print-install-files:
	@echo $(PREFIX)$(LIBDIR)
	@echo $(PREFIX)$(STATICDIR)
	@echo $(PREFIX)$(ELIOMSTATICDIR)
	@echo $(PREFIX)$(ETCDIR)

$(addprefix $(PREFIX),$(ETCDIR) $(LIBDIR)):
	install -d $@
$(addprefix $(PREFIX),$(DATADIR) $(LOGDIR) $(STATICDIR) $(ELIOMSTATICDIR) $(shell dirname $(CMDPIPE))):
	install $(addprefix -o ,$(WWWUSER)) -d $@

run.byte:
	$(OCSIGENSERVER) $(RUN_DEBUG) -c ${PREFIX}${ETCDIR}/${PROJECT_NAME}.conf
run.opt:
	$(OCSIGENSERVER.OPT) $(RUN_DEBUG) -c ${PREFIX}${ETCDIR}/${PROJECT_NAME}.conf

##----------------------------------------------------------------------
## Aux

# Use `eliomdep -sort' only in OCaml>4
ifeq ($(shell ocamlc -version|cut -c1),4)
eliomdep=$(shell $(ELIOMDEP) $(1) -ppx -sort $(2) $(filter %.eliom %.ml,$(3))))
else
eliomdep=$(3)
endif
objs=$(patsubst %.ml,$(1)/%.$(2),$(patsubst %.eliom,$(1)/%.$(2),$(filter %.eliom %.ml,$(3))))
depsort=$(call objs,$(1),$(2),$(call eliomdep,$(3),$(4),$(5)))

##----------------------------------------------------------------------
## Config files

FINDLIB_PACKAGES=$(patsubst %,\<extension\ findlib-package=\"%\"\ /\>,$(SERVER_PACKAGES))
EDIT_WARNING=DON\'T EDIT THIS FILE! It is generated from $(PROJECT_NAME).conf.in, edit that one, or the variables in Makefile.options
SED_ARGS := -e "/^ *%%%/d"
SED_ARGS += -e "s|%%PROJECT_NAME%%|$(PROJECT_NAME)|g"
SED_ARGS += -e "s|%%DATABASE_NAME%%|$(DATABASE_NAME)|g"
SED_ARGS += -e "s|%%DATABASE_USER%%|$(DATABASE_USER)|g"
SED_ARGS += -e "s|%%CMDPIPE%%|%%PREFIX%%$(CMDPIPE)|g"
SED_ARGS += -e "s|%%LOGDIR%%|%%PREFIX%%$(LOGDIR)|g"
SED_ARGS += -e "s|%%DATADIR%%|%%PREFIX%%$(DATADIR)|g"
SED_ARGS += -e "s|%%PERSISTENT_DATA_BACKEND%%|$(PERSISTENT_DATA_BACKEND)|g"
SED_ARGS += -e "s|%%LIBDIR%%|%%PREFIX%%$(LIBDIR)|g"
SED_ARGS += -e "s|%%WARNING%%|$(EDIT_WARNING)|g"
SED_ARGS += -e "s|%%PACKAGES%%|$(FINDLIB_PACKAGES)|g"
SED_ARGS += -e "s|%%ELIOMSTATICDIR%%|%%PREFIX%%$(ELIOMSTATICDIR)|g"
ifeq ($(DEBUG),yes)
  SED_ARGS += -e "s|%%DEBUGMODE%%|\<debugmode /\>|g"
else
  SED_ARGS += -e "s|%%DEBUGMODE%%||g"
endif

LOCAL_SED_ARGS := -e "s|%%PORT%%|$(TEST_PORT)|g"
LOCAL_SED_ARGS += -e "s|%%STATICDIR%%|$(LOCAL_STATIC)|g"
LOCAL_SED_ARGS += -e "s|%%USERGROUP%%||g"
GLOBAL_SED_ARGS := -e "s|%%PORT%%|$(PORT)|g"
GLOBAL_SED_ARGS += -e "s|%%STATICDIR%%|%%PREFIX%%$(STATICDIR)|g"
ifeq ($(WWWUSER)$(WWWGROUP),)
  GLOBAL_SED_ARGS += -e "s|%%USERGROUP%%||g"
else
  GLOBAL_SED_ARGS += -e "s|%%USERGROUP%%|<user>$(WWWUSER)</user><group>$(WWWGROUP)</group>|g"
endif

$(TEST_PREFIX)${ETCDIR}/${PROJECT_NAME}.conf: ${PROJECT_NAME}.conf.in Makefile.options | $(TEST_PREFIX)$(ETCDIR)
	sed $(SED_ARGS) $(GLOBAL_SED_ARGS) $< | sed -e "s|%%PREFIX%%|$(PREFIX)|g" > $@
$(TEST_PREFIX)${ETCDIR}/${PROJECT_NAME}-test.conf: ${PROJECT_NAME}.conf.in Makefile.options | $(TEST_PREFIX)$(ETCDIR)
	sed $(SED_ARGS) $(LOCAL_SED_ARGS) $< | sed -e "s|%%PREFIX%%|$(TEST_PREFIX)|g" > $@

##----------------------------------------------------------------------
## Server side compilation

SERVER_INC  := ${addprefix -package ,${SERVER_PACKAGES}}

${ELIOM_TYPE_DIR}/%.type_mli: %.eliom
	${ELIOMC} -infer ${SERVER_INC} $<

$(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cma: $(call objs,$(ELIOM_SERVER_DIR),cmo,$(SERVER_FILES)) | $(TEST_PREFIX)$(LIBDIR)
	${ELIOMC} -a -o $@ $(GENERATE_DEBUG) \
          $(call depsort,$(ELIOM_SERVER_DIR),cmo,-server,$(SERVER_INC),$(SERVER_FILES))

$(TEST_PREFIX)$(LIBDIR)/$(PROJECT_NAME).cmxa: $(call objs,$(ELIOM_SERVER_DIR),cmx,$(SERVER_FILES)) | $(TEST_PREFIX)$(LIBDIR)
	${ELIOMOPT} -a -o $@ $(GENERATE_DEBUG) \
          $(call depsort,$(ELIOM_SERVER_DIR),cmx,-server,$(SERVER_INC),$(SERVER_FILES))

%.cmxs: %.cmxa
	$(ELIOMOPT) -shared -linkall -o $@ $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmi: %.mli
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmi: %.eliomi
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmo: %.ml
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmo: %.eliom
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmx: %.ml
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmx: %.eliom
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<


##----------------------------------------------------------------------
## Client side compilation

CLIENT_LIBS := ${addprefix -package ,${CLIENT_PACKAGES}}
CLIENT_INC  := ${addprefix -package ,${CLIENT_PACKAGES}}

CLIENT_OBJS := $(filter %.eliom %.ml, $(CLIENT_FILES))
CLIENT_OBJS := $(patsubst %.eliom,${ELIOM_CLIENT_DIR}/%.cmo, ${CLIENT_OBJS})
CLIENT_OBJS := $(patsubst %.ml,${ELIOM_CLIENT_DIR}/%.cmo, ${CLIENT_OBJS})

$(TEST_PREFIX)$(ELIOMSTATICDIR)/$(PROJECT_NAME).js: $(call objs,$(ELIOM_CLIENT_DIR),cmo,$(CLIENT_FILES)) | $(TEST_PREFIX)$(ELIOMSTATICDIR)
	${JS_OF_ELIOM} -o $@ $(GENERATE_DEBUG) $(CLIENT_INC) $(DEBUG_JS) \
          $(call depsort,$(ELIOM_CLIENT_DIR),cmo,-client,$(CLIENT_INC),$(CLIENT_FILES))

${ELIOM_CLIENT_DIR}/%.cmi: %.mli
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmo: %.eliom
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<
${ELIOM_CLIENT_DIR}/%.cmo: %.ml
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmi: %.eliomi
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

##----------------------------------------------------------------------
## Dependencies

include .depend

.depend: $(patsubst %,$(DEPSDIR)/%.server,$(SERVER_FILES)) $(patsubst %,$(DEPSDIR)/%.client,$(CLIENT_FILES))
	cat $^ > $@

$(DEPSDIR)/%.server: % | $(DEPSDIR)
	$(ELIOMDEP) -server -ppx $(SERVER_INC) $< > $@

$(DEPSDIR)/%.client: % | $(DEPSDIR)
	$(ELIOMDEP) -client -ppx $(CLIENT_INC) $< > $@

$(DEPSDIR):
	mkdir $@

##----------------------------------------------------------------------
## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f *.type_mli
	-rm -f ${PROJECT_NAME}.js
	-rm -rf ${ELIOM_CLIENT_DIR} ${ELIOM_SERVER_DIR}

distclean: clean
	-rm -rf $(TEST_PREFIX) $(DEPSDIR) .depend

=== debian/changelog ===
eliom (9.4.0-2) unstable; urgency=medium

  * Add libjs-of-ocaml-ocamlbuild-ocaml-dev to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Mon, 07 Mar 2022 06:15:20 +0100

eliom (9.4.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 23 Feb 2022 15:46:43 +0100

eliom (6.12.4-2) unstable; urgency=medium

  * Add libppx-tools-versioned-ocaml-dev to Build-Depends
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 05 Dec 2021 09:40:08 +0100

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,22 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml-nox (>= 4.07.1),
+ ocaml,
  ocaml-findlib,
  ocamlbuild,
  libppx-deriving-ocaml-dev,
- libppx-tools-ocaml-dev,
- libjs-of-ocaml-dev (>= 3.5.1),
+ libjs-of-ocaml-dev (>= 3.6.0),
+ libjs-of-ocaml-ocamlbuild-ocaml-dev,
  liblwt-log-ocaml-dev,
  liblwt-ocaml-dev,
  libtyxml-ocaml-dev (>= 4.4.0),
- libocsigenserver-ocaml-dev (>= 2.10),
+ libocsigenserver-ocaml-dev (>= 5.0.0),
+ libocsipersist-ocaml-dev,
  libipaddr-ocaml-dev (>= 2.1),
  libreactivedata-ocaml-dev (>= 0.2.1),
+ libppxlib-ocaml-dev (>= 0.15.0),
  opam-installer
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://ocsigen.org/eliom
 Vcs-Browser: https://salsa.debian.org/ocaml-team/eliom

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,6 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
-export OCAMLFIND_LDCONF=ignore
-
 %:
 	dh $@ --with ocaml

## eliom 10.0.0

=== debian/changelog ===
eliom (10.0.0-1build10) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Aug 2023 18:06:42 +0200

eliom (10.0.0-1build9) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Aug 2023 20:04:01 +0200

eliom (10.0.0-1build8) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Aug 2023 09:35:57 +0200

eliom (10.0.0-1build7) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 18 Aug 2023 21:12:57 +0200

eliom (10.0.0-1build6) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jul 2023 05:37:22 +0200

eliom (10.0.0-1build5) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jul 2023 10:36:41 +0200

eliom (10.0.0-1build4) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Jul 2023 19:16:52 +0200

eliom (10.0.0-1build3) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 22 Jul 2023 08:23:10 +0200

eliom (10.0.0-1build2) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Jul 2023 08:19:16 +0200

eliom (10.0.0-1build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 08 Jul 2023 03:14:23 +0200

eliom (10.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump standards-version to 4.6.2

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 10:22:47 +0200

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
  libreactivedata-ocaml-dev (>= 0.2.1),
  libppxlib-ocaml-dev (>= 0.15.0),
  opam-installer
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://ocsigen.org/eliom
 Vcs-Browser: https://salsa.debian.org/ocaml-team/eliom

## eliom 10.1.0

=== Makefile ===
--- 
+++ 
@@ -43,45 +43,15 @@
 	cp -Rf doc/index.wiki $(API_DIR)/
 
 
-### Testing ###
-
-.PHONY: run.local run.opt.local links
-
-run.local: tests.byte fifo tests/eliom.conf
-	OCAMLPATH=tests/:$(OCAMLPATH) ocsigenserver -c tests/eliom.conf
-
-run.opt.local: tests.opt fifo tests/eliom.conf
-	OCAMLPATH=tests/:$(OCAMLPATH) ocsigenserver.opt -c tests/eliom.conf
-
-tests.byte: links
-	${MAKE} -C tests byte
-
-tests.opt: links
-	${MAKE} -C tests opt
-
-links:
-	-mkdir -p local/var/run
-	-mkdir -p local/var/log
-	-mkdir -p local/var/lib
-	-mkdir -p local/tmp
-
-fifo:
-	[ -p local/var/run/eliom_command ] || \
-	 { mkfifo local/var/run/eliom_command; \
-	   chmod 660 local/var/run/eliom_command; }
-
-
 ### Cleaning ###
 .PHONY: clean clean.local distclean
 clean: clean.local
 	ocamlbuild -quiet -no-plugin -clean
-	${MAKE} -C tests clean
 
 clean.local:
 	-rm -f eliom-*.tar.gz
 
 distclean: clean clean.local
-	${MAKE} -C tests distclean
 	-find ./ -name "*\#*" | xargs rm -f
 
 ### Installation ####

=== debian/changelog ===
eliom (10.1.0-2build1) noble; urgency=medium

  * Rebuild against 'new OCAML ABIs'.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Dec 2023 07:57:11 +0100

eliom (10.1.0-2) unstable; urgency=medium

  * Attempt to fix compilation on armhf buildds

 -- Stéphane Glondu <glondu@debian.org>  Sat, 30 Sep 2023 11:33:58 +0200

eliom (10.1.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 26 Sep 2023 02:26:08 +0200

eliom (10.0.0-2) unstable; urgency=medium

  * Fix compilation with ocsigenserver 5.1.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 23 Sep 2023 18:10:00 +0200

=== debian/control ===
--- 
+++ 
@@ -16,11 +16,12 @@
  liblwt-log-ocaml-dev,
  liblwt-ocaml-dev,
  libtyxml-ocaml-dev (>= 4.4.0),
- libocsigenserver-ocaml-dev (>= 5.0.0),
+ libocsigenserver-ocaml-dev (>= 5.1.0),
  libocsipersist-ocaml-dev,
  libipaddr-ocaml-dev (>= 2.1),
  libreactivedata-ocaml-dev (>= 0.2.1),
  libppxlib-ocaml-dev (>= 0.15.0),
+ libppx-optcomp-ocaml-dev,
  opam-installer
 Standards-Version: 4.6.2
 Rules-Requires-Root: no

## eliom 10.2.0

=== Makefile ===
--- 
+++ 
@@ -1,21 +1,11 @@
 ### Building
 BEST=$(if $(shell command -v ocamlopt 2> /dev/null),native,byte)
 BUILDER=_build/build/build.$(BEST)
-BUILD=ocaml pkg/build.ml
 
-.PHONY: all byte native builder
-all: $(BEST)
+.PHONY: all
+all:
+	dune build
 
-byte: $(BUILDER)
-	# strange, see https://sympa.inria.fr/sympa/arc/ocsigen/2016-01/msg00016.html
-	$(BUILDER) src/lib/server/eliommod_sessiongroups.cmi
-	$(BUILD) manpage=false native=false native-dynlink=false
-native: $(BUILDER)
-	$(BUILD) manpage=false native=true native-dynlink=true
-
-$(BUILDER): $(wildcard build/*.ml)
-	ocamlbuild -no-plugin -I src/ocamlbuild -no-links -use-ocamlfind build/build.$(BEST) 1> /dev/null
-builder: $(BUILDER)
 ### Doc
 .PHONY: doc wikidoc doc man alldoc
 DOCS_DIR=src/lib/client src/lib/server src/ocamlbuild src/ppx
@@ -42,16 +32,16 @@
 	cp -Rf _build/src/ppx/api.wikidocdir/*.wiki $(API_DIR)/ppx/
 	cp -Rf doc/index.wiki $(API_DIR)/
 
+$(BUILDER): $(wildcard build/*.ml)
+	ocamlbuild -no-plugin -I src/ocamlbuild -no-links -use-ocamlfind build/build.$(BEST) 1> /dev/null
+builder: $(BUILDER)
 
 ### Cleaning ###
-.PHONY: clean clean.local distclean
-clean: clean.local
-	ocamlbuild -quiet -no-plugin -clean
+.PHONY: clean distclean
+clean:
+	dune clean
 
-clean.local:
-	-rm -f eliom-*.tar.gz
-
-distclean: clean clean.local
+distclean: clean
 	-find ./ -name "*\#*" | xargs rm -f
 
 ### Installation ####

=== pkg/distillery/templates/client-server.basic/Makefile ===
#----------------------------------------------------------------------
#           GLOBAL MAKEFILE
#----------------------------------------------------------------------

# Local settings (optional). See Makefile.local.example for an example.
# WARNING: do not commit to a repository!
-include Makefile.local

# Eliom settings. Contains all variables.
include Makefile.options

# Eliom default makefile
# Makefile.PROJECT_NAME is also included in this makefile
include Makefile.eliom

=== debian/changelog ===
eliom (10.2.0-1build3) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Feb 2024 19:42:06 +0100

eliom (10.2.0-1build2) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Feb 2024 07:59:25 +0100

eliom (10.2.0-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:28:58 +0100

eliom (10.2.0-1) unstable; urgency=medium

  * New upstream release
    - use ocaml_dune dh build system
    - building doc is broken upstream; drop libeliom-ocaml-doc altogether

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Feb 2024 08:21:38 +0100

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,10 @@
  Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-ocaml,
+ dh-ocaml (>= 2),
  ocaml,
  ocaml-findlib,
+ ocaml-dune (>= 3.6),
  ocamlbuild,
  libppx-deriving-ocaml-dev,
  libjs-of-ocaml-dev (>= 3.6.0),
@@ -65,16 +66,3 @@
  applications using OCaml.
  .
  This package contains all the library files needed to use Eliom.
-
-Package: libeliom-ocaml-doc
-Section: doc
-Architecture: all
-Multi-Arch: foreign
-Depends: ${misc:Depends}
-Enhances: libeliom-ocaml-dev
-Description: web framework for ocsigenserver (documentation)
- Eliom allows one to easily develop sophisticated client/server Web
- applications using OCaml.
- .
- This package contains documentation: the manual (in wikicreole
- format) and the API reference generated by ocamldoc (in HTML format).

## eliom 10.4.1

=== debian/changelog ===
eliom (10.4.1-1build3) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Jun 2024 06:55:36 +0200

eliom (10.4.1-1build2) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jun 2024 10:51:22 +0200

eliom (10.4.1-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jun 2024 09:52:46 +0200

eliom (10.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 10.4.1
  * Set std-ver to 4.7.0

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 05 Jun 2024 07:05:05 +0200

## eliom 11.0.1

=== debian/changelog ===
eliom (11.0.1-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Sep 2024 08:23:30 +0200

eliom (11.0.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 24 Sep 2024 16:01:00 +0200
